package org.manzerbredes.open_klm.device;

import java.util.HashMap;

import org.manzerbredes.open_klm.device.Driver.*;

public class Keyboard{
	
	/**
	 * Device driver
	 */
	private Driver device;
	
	/**
	 * Define Keyboard color state
	 */
	private HashMap<Region, Color> KeyboardColor=new HashMap<>();
	
	/**
	 * Define Keyboard mode state
	 */
	private Mode mode=Mode.NORMAL;

	/**
	 * Build a keyboard access
	 */
	public Keyboard(){
		try {
			this.device=new Driver();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	/**
	 * 
	 * Change global keyboard color
	 * 
	 * @param color Color to apply
	 * @param intensity Intensity wanted
	 */
	public void setColor(Color color, Intensity intensity){
		// Save state
		this.KeyboardColor.put(Region.LEFT, color);
		this.KeyboardColor.put(Region.MIDDLE, color);
		this.KeyboardColor.put(Region.RIGHT, color);
		
		// Set color
		this.device.setColor(Region.LEFT, color, intensity);
		this.device.setColor(Region.MIDDLE, color, intensity);
		this.device.setColor(Region.RIGHT, color, intensity);
		
		// Apply color
		this.device.commit(this.mode);

	}
	
	/**
	 * 
	 * Change region keyboard color
	 * 
	 * @param region Region to apply the color
	 * @param color Color to apply
	 * @param intensity Intensity wanted
	 */
	public void setRegionColor(Region region, Color color, Intensity intensity){
		// Save state
		this.KeyboardColor.put(region, color);
		
		// Set color
		this.device.setColor(region, color, intensity);
		
		// Apply color
		this.device.commit(this.mode);

	}
	
}